/*
 * Copyright (c) 2012 Google Inc.
 *
 * All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 */
package com.google.eclipse.protobuf.naming;

import org.eclipse.emf.ecore.EObject;

/**
 * @author alruiz@google.com (Alex Ruiz)
 */
class NormalNamingStrategy implements NamingStrategy {
  private final NameResolver nameResolver;

  public NormalNamingStrategy(NameResolver nameResolver) {
    this.nameResolver = nameResolver;
  }

  @Override public String nameOf(EObject e) {
    return nameResolver.nameOf(e);
  }
}
